/* J[\ɂ`Xg̗p */

/* ֐PurgeƊ֐RetrievẽeXgList9-6ɒǉ */

#include <stdio.h>
#include "Member.h"
#include "ArrayLinkedList.h"

/*--- j[ ---*/
typedef enum {
	TERMINATE, INS_FRONT, INS_REAR,  RMV_FRONT, RMV_REAR, PRINT_CRNT,
	RMV_CRNT,  SRCH_NO,   SRCH_NAME, PRINT_ALL, CLEAR,
	PURGE_NO, PURGE_NAME, RETRIEVE,
} Menu;

/*--- j[I ---*/
Menu SelectMenu(void)
{
	int  i, ch;
	char *mstring[] = {
		"擪Ƀm[h}", "Ƀm[h}",	"擪̃m[h폜",
		"̃m[h폜", "ڃm[h\",	"ڃm[h폜",
		"ԍŒT",		  "ŒT",			"Sm[h\",
		"Sm[h폜",	  "ԍm[h폜", "m[h폜",
		"nԖڂ̃m[h"
	};

	do {
		for (i = TERMINATE; i < RETRIEVE; i++) {
			printf("(%2d) %-18.18s  ", i + 1, mstring[i]);
			if ((i % 3) == 2)
				putchar('\n');
		}
		printf("( 0) I F");
		scanf("%d", &ch);
	} while (ch < TERMINATE || ch > RETRIEVE);

	return (Menu)ch;
}

/*--- C ---*/
int main(void)
{
	Menu menu;
	List list;

	Initialize(&list, 30);				/* `Xg̏ */

	do {
		int n;
		Member x;
		Index ptr;

		switch (menu = SelectMenu()) {
		 /* 擪Ƀm[h} */
		 case INS_FRONT :
				x = ScanMember("擪ɑ}", MEMBER_NO | MEMBER_NAME);
				InsertFront(&list, &x);
				break;

		 /* Ƀm[h} */
		 case INS_REAR :
				x = ScanMember("ɑ}", MEMBER_NO | MEMBER_NAME);
				InsertRear(&list, &x);
				break;

		 /* 擪m[h폜 */
		 case RMV_FRONT :
				RemoveFront(&list);
				break;

		 /* m[h폜 */
		 case RMV_REAR :
				RemoveRear(&list);
				break;

		 /* ڃm[h̃f[^\ */
		 case PRINT_CRNT :
				PrintLnCurrent(&list);
				break;

		 /* ڃm[h폜 */
		 case RMV_CRNT :
				RemoveCurrent(&list);
				break;

		 /* ԍɂT */
		 case SRCH_NO :
				x = ScanMember("T", MEMBER_NO);
				if (Search(&list, &x, MemberNoCmp) != Null)
					PrintLnCurrent(&list);
				else
					puts("̔ԍ̃f[^͂܂B");
				break;

		 /* ɂT */
		 case SRCH_NAME :
				x = ScanMember("T", MEMBER_NAME);
				if (Search(&list, &x, MemberNameCmp) != Null)
					PrintCurrent(&list);
				else
					puts("̖Õf[^͂܂B");
				break;

		 /* Sm[h̃f[^\ */
		 case PRINT_ALL :
				Print(&list);
				break;

		 /* Sm[h폜 */
		 case CLEAR :
				Clear(&list);
				break;

		/* ԍvSm[h폜 */
		 case PURGE_NO :
				Purge(&list, MemberNoCmp);
				break;

		/* vSm[h폜 */
		 case PURGE_NAME :
				Purge(&list, MemberNameCmp);
				break;

		/* nԖڂ̃m[h\ */
		 case RETRIEVE :
				printf("擪牽F");
				scanf("%d", &n);
				if ((ptr = Retrieve(&list, n)) != Null)
					PrintLnMember(&list.n[ptr].data);
				else
					puts("̃f[^͂܂B");
				break;
		}
	} while (menu != TERMINATE);

	Terminate(&list);							/* `Xǧn */

	return 0;
}
