/* int^fbNIntDequeueiwb_j*/

#ifndef ___IntDequeue
#define ___IntDequeue

/*--- L[\ ---*/
typedef struct {
	int max;		/* L[̗e */
	int num;		/* ݂̗vf */
	int front;		/* 擪vfJ[\ */
	int rear;		/* vfJ[\ */
	int *que;		/* L[{́i̐擪vfւ̃|C^j*/
} IntDequeue;

/*--- L[̏ ---*/
int Initialize(IntDequeue *q, int max);

/*--- L[̐擪Ƀf[^GL[ ---*/
int EnqueFront(IntDequeue *q, int x);

/*--- L[̖Ƀf[^GL[ ---*/
int EnqueRear(IntDequeue *q, int x);

/*--- L[̐擪f[^fL[ ---*/
int DequeFront(IntDequeue *q, int *x);

/*--- L[̖f[^fL[ ---*/
int DequeRear(IntDequeue *q, int *x);

/*--- L[̐擪f[^s[N ---*/
int PeekFront(const IntDequeue *q, int *x);

/*--- L[̖f[^s[N ---*/
int PeekRear(const IntDequeue *q, int *x);

/*--- Sf[^폜 ---*/
void Clear(IntDequeue *q);

/*--- L[̗e ---*/
int Capacity(const IntDequeue *q);

/*--- L[̃f[^ ---*/
int Size(const IntDequeue *q);

/*--- L[͋ ---*/
int IsEmpty(const IntDequeue *q);

/*--- L[͖t ---*/
int IsFull(const IntDequeue *q);

/*--- L[̒T ---*/
int Search(const IntDequeue *q, int x);

/*--- L[̒Ti_IYԋpj---*/
int Search2(const IntDequeue *q, int x);

/*--- Sf[^̕\ ---*/
void Print(const IntDequeue *q);

/*--- L[̌n ---*/
void Terminate(IntDequeue *q);

#endif
